<?php
/*
Plugin Name: Clients by ModernThemes
Plugin URI: http://modernthemes.net/plugins/clients
Description: This is a plugin by ModernThemes that adds Clients post types and widgets.
Version: 1.1.7
Author: ModernThemes
Author URI: http://modernthemes.net/
License: GPL2
Text Domain: clients 
Domain Path: /languages/
*/


require 'plugin-updates/plugin-update-checker.php';  
$MyUpdateChecker = PucFactory::buildUpdateChecker(
'http://modernthemes.net/updates/?action=get_metadata&slug=mt_clients', //Metadata URL.
__FILE__, //Full path to the main plugin file. 
'mt_clients' //Plugin slug 
);


add_action('admin_init', 'mt_clientssettings_flush' ); 

function mt_clientssettings_flush(){ 

		if ( isset( $_POST['mt_clientssettings_options'] ) ) { 


			flush_rewrite_rules();
		
		}

}

/* Paths for Files */
$mt_clients_main_file = dirname(__FILE__).'/clients-by-mt.php';
$mt_clients_directory = plugin_dir_url($mt_clients_main_file);
$mt_clients_path = dirname(__FILE__);

/* Add css and scripts file */ 
function mt_clients_add_scripts() {
	global $mt_clients_directory, $mt_clients_path; 
		wp_enqueue_style('mt-clients-style', $mt_clients_directory.'css/grid.css');  
}
		
add_action('wp_enqueue_scripts', 'mt_clients_add_scripts'); 


class MT_Clients_Widgets { 
	public function __construct() {
		add_action( 'widgets_init', array( $this, 'load' ), 9 );
		add_action( 'widgets_init', array( $this, 'init' ), 10 );
		register_uninstall_hook( __FILE__, array( __CLASS__, 'uninstall' ) );
	}

	public function load() {
		$dir = plugin_dir_path( __FILE__ );

		include_once( $dir . 'inc/widget-mt-clients.php' );
		include_once( $dir . 'inc/mt-clients.php' ); 
		include_once( $dir . 'inc/shortcodes-mt-clients.php' );
		
	}

	public function init() {
		if ( ! is_blog_installed() ) {
			return;
		}

		load_plugin_textdomain( 'mtclients', false, 'mt_clients/languages' );
		
		register_widget( 'mt_clients' ); 
		
	}

	public function uninstall() {}
}

$mt_clients_widgets = new MT_Clients_Widgets();